[![CRAM_Status_Badge](http://www.r-pkg.org/badges/version/vcpen)](https://CRAN.R-project.org/package=smart)
[![Downloads](http://cranlogs.r-pkg.org/badges/vcpen)](https://CRAN.R-project.org/package=smart)
[![Total-Downloads](https://cranlogs.r-pkg.org/badges/grand-total/vcpen)](https://CRAN.R-project.org/package=smart)

# The `smart` Package
Sequential clinical trial design ..., with Single Sequential Treatment (SST) and Dynamic Treatment (DTR) designs, for which we split into separate calculations and plot methods.

# `meanSST()`

Performs sensitivity, specificity, and power calculations for the SST design given means for G0 and G1, and sample size. User specifies the B level to be applied in the power and the plot functions.

# `varianceSST()`

Performs sensitivity, specificity, and power calculations for the SST design given variances for G0 and G1, and sample size. User specifies the B level to be applied in the power and the plot functions.

# `responseDTR()`

Function provided to make it easier to create the named vector for response means for the DTR,
but is used within `meanSST()` for setting up the response means for that simpler scenario.

# `sigmaDTR()`

Function provided to make it easier to create the named vector for response variances (sigma) for the DTR, but is used within `varianceSST()` for setting up the response means for that simpler scenario.

# `meanDTR()`

Performs sensitivity, specificity, and power calculations for the more-flexible DTR design given a sample size and means for all 16 A, B, G, and R groups. User specifies the B level to be applied in the power and the plot functions.

# `varianceDTR()`

Performs sensitivity, specificity, and power calculations for the more-flexible DTR design given variances for G0 and G1, and sample size. User specifies the B level to be applied in the power and the plot functions.

