\name{powerDTR}
\alias{powerDTR}
\alias{print.powerDTR}
\alias{plot.powerDTR}
\title{Power Dynamic Treatment Regimen (DTR) Trial design clinical trial calculations}
\description{
Power Calculations Comparing two Dynamic Treatment Regimen (DTR) Trial design clinical trial calculations
}
\usage{
powerDTR(dtr1, dtr2, power="response", 
      pG_A1 = 0.5, pG_A2 = 0.5, alpha=0.05)
}
\arguments{
  \item{dtr1}{an object of smartDTR class, created by function of the
    same name}
  \item{dtr2}{an object of smartDTR class, created by function of the
    same name}
  \item{pG_A1}{probability of response to therapy given assignment to A1}
  \item{pG_A2}{probability of response to therapy given assignment to A2}
  \item{alpha}{accepted type-I error rate for power calculations}
}
\details{
 more details on power DTR
}
\value{
  An object of the powerDTR S3 class, with the following elements:
  \item{powerdat: }{data.frame with sens, spec, mu, sigsq and sample
    size, power
  }
}
\references{
 
  Example: Davies RB (1980) Algorithm AS 155: The Distribution of a Linear
  Combination of chi-2 Random Variables, Journal of the Royal
  Statistical Society. Series C (Applied Statistics), 29(3):323-33
}
\author{
Jun (Jessie) He, Aberaham Eyman-Casey, Jason P. Sinnwell, Mayo Clinic
}

\examples{
## example here

}

